<?php



/**

 *  Written By Raul Reynoso info@webologysolutions.com



Copyright (C) 2009  Webology eBusiness Solutions



This program is free software; you can redistribute it and/or

modify it under the terms of the GNU General Public License

as published by the Free Software Foundation; either version 2

of the License, or (at your option) any later version.



This program is distributed in the hope that it will be useful,

but WITHOUT ANY WARRANTY; without even the implied warranty of

MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

GNU General Public License for more details.



You should have received a copy of the GNU General Public License

along with this program; if not, write to the Free Software

Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.





You can view an online copy of the license at: http://www.gnu.org/licenses/gpl-2.0.html

 



 **/





//no direct access



(defined('_VALID_MOS') OR defined('_JEXEC')) or die('Direct Access to this location is not allowed.');



if(!defined('CMSLIB_DEFINED') && defined('_JEXEC')){

	include_once( dirname(dirname(dirname(__FILE__))). '/components/libraries/cmslib/spframework.php');

	}

else if(!defined('CMSLIB_DEFINED')) {

	include_once( dirname(dirname(__FILE__)). '/components/libraries/cmslib/spframework.php');

}



$cms	=& cmsInstance('CMSCore');



include_once($cms->get_path('root'). "/components/com_myblog/modules/mod_myblog.php");



$objModule = new MyblogModule();



showRelatedEntries($params);

// When no id can be found this function 
// Returns Id to use for selecting selecting related blog posts.
function my_blog_related_getDefaultBehavior($params){
	$action = $params->get('default_action','blank');
	if($action == 'blank'){
		return -1;
	}
	elseif($action == 'last_post'){
		return myblog_related_latest_post_id();
	}
	elseif($action == 'popular'){
		return myblog_related_most_popular_id();
	}
	elseif($action == 'random'){
		return mod_myblog_related_random();
	}
	elseif($action == 'specify'){
		return  $params->get('blog_post_id',-1);
	}
}
function myblog_related_latest_post_id(){
	global $_MY_CONFIG;
	$sections =	$_MY_CONFIG->get('managedSections');
	$query ="SELECT id
			FROM `#__content` 
			Where sectionid in (".$sections.")
			AND state =1
			AND publish_up < NOW() AND (publish_down =0 OR publish_down > NOW())
			ORDER BY publish_up DESC
			Limit 0,1";
	return myblog_related_return_id(0,$query);
}

function myblog_related_most_popular_id(){
	global $_MY_CONFIG;
	$sections =	$_MY_CONFIG->get('managedSections');
	$query ="SELECT id
			FROM `#__content` 
			Where sectionid in (".$sections.")
			AND state =1
			AND publish_up < NOW() AND (publish_down =0 OR publish_down > NOW())
			ORDER BY hits DESC
			Limit 0,1";
	return myblog_related_return_id(0,$query);
}

function mod_myblog_related_random(){
	$query ="SELECT contentid
			FROM `#__myblog_permalinks` 
			ORDER BY RAND() LIMIT 0,1";
	return myblog_related_return_id(0,$query);
}

function myblog_related_return_id($pos,$query) {
 	$db =& JFactory::getDBO();
	$db->setQuery($query);
	$db->query();
	$result = $db->loadResultArray(0);
	return $result[$pos];
}
function mod_myblog_related_getContentId($params){

    // Id's can be passed in show variable if viewed through the myblog component

	// Id's can be passed though id variable if viewed through content component

	$temp                = JRequest::getString('show');

	if($temp ==''){

		// id not passed in t show variable.  Try id variable

		$temp                = JRequest::getString('id');

		if($temp ==''){

			// No id for any content passed.
			$id = my_blog_related_getDefaultBehavior($params);
			if($id ==''){
				return -1;
			}
			return $id;

		}

	}

	// ######### Done Determining Source of ID	

	$temp                = explode(':', $temp);

	$val                    = $temp[0];

	if(is_numeric($val)){ 	

		return $val;

	}

	

	$db =& JFactory::getDBO();

	$query ="SELECT contentid

			FROM `#__myblog_permalinks` 

			WHERE permalink ='". $val."'";

	$db->setQuery($query);

	$db->query();

	$result = $db->loadResultArray(0);



	return $result[0];

}



function showRelatedEntries(&$params){



	global $_MY_CONFIG;



	$id = mod_myblog_related_getContentId($params);

	// exit if there is now id to show from.

	// this module will not appear.

 	if ($id ==-1){return;}

	$limit = $params->get('count',5);

	$db =& JFactory::getDBO();

	$query ="SELECT DISTINCT content.title, cc1.contentid AS articleid, cc2.contentid AS relatedid, sum( cc2.category ) AS incommon

			FROM `#__myblog_content_categories` AS cc1

			INNER JOIN `#__myblog_content_categories` AS cc2 ON cc1.category = cc2.category

			INNER JOIN `#__content` as content on cc2.contentid=content.id

			WHERE cc1.contentid != cc2.contentid AND cc1.contentid =". $id."

			GROUP BY cc1.contentid, cc2.contentid

			ORDER BY incommon DESC 

			LIMIT 0 , $limit";


	$db->setQuery($query);

	

	$db->query();



	$entries = $db->loadRowList();



	$links='<ul  class="myblog-related">';

	foreach ($entries as $row){



		$url = myGetPermalinkUrl($row[2]);



		$links	.= "<li  class=\"myblog-related\"><a href='".$url."' class=\"myblog-related\">".$row[0]."</a></li>";



	}



	echo $links."</ul>";

}

?>